attribute vec3 aPosition;  //顶点位置
attribute vec3 aNormal; // 法向量
uniform vec3 uLightLocation;						// 光源位置
varying vec4 vDiffuse;							//用于传递给片元着色器的散射光分量
varying vec4 vAmbient;							//用于传递给片元着色器的环境光分量
varying vec4 vSpecular;							//用于传递给片元着色器的镜面光分量
void main()
{
   gl_Position = vec4(aPosition,1);
   vec3 eyePosition = vec3(0.0, 0.0, 1.0);
   vec3 lightAmbient = vec3(1.0, 1.0, 1.0);  //  环境光
   vec3 lightDiffuse = vec3(1.0, 1.0, 1.0);  // 漫反射
   vec3 lightSpecular = vec3(1.0, 1.0, 1.0);  // 镜面反射
   vec3 materialAmbient = vec3(0.0, 0.0, 1.0);  // 环境材质
   vec3 materialDiffuse = vec3(0.0, 0.0, 1.0);  // 漫反射材质
   vec3 materialSpecular = vec3(0.0, 0.0, 1.0);// 镜面材质
   float shininess = 8.0; // 0-128 镜面光斑

   vec3 n_lightDirection = normalize(uLightLocation);
   float cosNL = max(dot(aNormal, n_lightDirection), 0.0);
   vDiffuse = vec4(lightDiffuse * materialDiffuse, 1.0) * cosNL;
   vAmbient = vec4(lightAmbient * materialAmbient, 1.0);

   vec3 n_eyePosition = normalize(eyePosition - vec4(aPosition,1).xyz);
   vec3 reflection = ((2.0 * cosNL) * aNormal) - n_lightDirection;
   float powValue = pow(max(dot(n_eyePosition, reflection), 0.0), shininess);
   vSpecular = vec4(lightSpecular * materialSpecular * powValue, 1.0);
}